require File.expand_path(File.dirname(__FILE__) + "/../spec_helper")
require 'austin/austin'

describe Austin::Austin do
  
  before do
    @word_list = %w(foo bar)
  end
  
  it "should instantiate" do
    lambda { Austin::Austin.new }.should_not raise_error
  end
  
  describe "after instantiating" do
    before do
      @me = Austin::Austin.new
    end
    
    it "should be able to create a new game" do
      @me.word_list = @word_list
      @me.new_game(6).is_a?(Austin::Hangman).should be_true
    end
    
    describe "after creating a new game" do
      before do
        @hm = @me.new_game(6)
      end
      
      it "Hangman should know the word list" do
        Austin::Hangman.word_list.should == @word_list
      end
      
      it "should know it's game" do
        @me.game.should == @hm
      end
      
      it "should guess a letter" do
        word = '____'
        letter_guessed = @me.guess(word, 6)
        ('a'..'z').to_a.include?(letter_guessed).should be_true
      end
    end
  end

end